diff --git a/misc/efgcvt-template.c b/misc/efgcvt-template.c
index 7fabdf264d..fe4c28bf0f 100644
--- a/misc/efgcvt-template.c
+++ b/misc/efgcvt-template.c
@@ -23,6 +23,10 @@
 #include <libc-lock.h>
 #include <math_ldbl_opt.h>
 
+#ifndef SPRINTF
+# define SPRINTF sprintf
+#endif
+
 #define APPEND(a, b) APPEND2 (a, b)
 #define APPEND2(a, b) a##b
 
@@ -66,6 +70,6 @@ __ECVT (FLOAT_TYPE value, int ndigit, int *decpt, int *sign)
 char *
 __GCVT (FLOAT_TYPE value, int ndigit, char *buf)
 {
-  sprintf (buf, "%.*" FLOAT_FMT_FLAG "g", MIN (ndigit, NDIGIT_MAX), value);
+  SPRINTF (buf, "%.*" FLOAT_FMT_FLAG "g", MIN (ndigit, NDIGIT_MAX), value);
   return buf;
 }
diff --git a/misc/efgcvt_r-template.c b/misc/efgcvt_r-template.c
index 977750118c..bae2d30a77 100644
--- a/misc/efgcvt_r-template.c
+++ b/misc/efgcvt_r-template.c
@@ -25,6 +25,10 @@
 #include <sys/param.h>
 #include <math_ldbl_opt.h>
 
+#ifndef SNPRINTF
+# define SNPRINTF __snprintf
+#endif
+
 
 #define APPEND(a, b) APPEND2 (a, b)
 #define APPEND2(a, b) a##b
@@ -73,7 +77,7 @@ __FCVT_R (FLOAT_TYPE value, int ndigit, int *decpt, int *sign,
     /* Value is Inf or NaN.  */
     *sign = 0;
 
-  n = __snprintf (buf, len, "%.*" FLOAT_FMT_FLAG "f", MIN (ndigit, NDIGIT_MAX),
+  n = SNPRINTF (buf, len, "%.*" FLOAT_FMT_FLAG "f", MIN (ndigit, NDIGIT_MAX),
 		  value);
   /* Check for a too small buffer.  */
   if (n >= (ssize_t) len)
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/Makefile b/sysdeps/ieee754/ldbl-128ibm-compat/Makefile
index 6d5414c54a..49d9af9fea 100644
--- a/sysdeps/ieee754/ldbl-128ibm-compat/Makefile
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/Makefile
@@ -251,10 +251,18 @@ endif
 ifeq ($(subdir),misc)
 ldbl-extra-routines += err \
 		       error \
-		       syslog
+		       syslog \
+		       qefgcvt \
+		       qefgcvt_r
+
+CFLAGS-ieee128-qefgcvt.c += -mabi=ieeelongdouble -Wno-psabi -mno-gnu-attribute
+CFLAGS-ieee128-qefgcvt_r.c += -mabi=ieeelongdouble -Wno-psabi -mno-gnu-attribute
 
 tests-internal += tst-ibm128-warn tst-ieee128-warn
 tests-internal += tst-ibm128-error tst-ieee128-error
+tests-internal += tst-ibm128-efgcvt tst-ieee128-efgcvt
+
+$(objpfx)tst-ieee128-efgcvt: gnulib-tests += $(f128-loader-link)
 
 $(objpfx)tst-ibm128-%.c: tst-ldbl-%.c
 	cp $< $@
@@ -264,9 +272,11 @@ $(objpfx)tst-ieee128-%.c: tst-ldbl-%.c
 
 CFLAGS-tst-ibm128-warn.c += -mabi=ibmlongdouble -Wno-psabi
 CFLAGS-tst-ibm128-error.c += -mabi=ibmlongdouble -Wno-psabi
+CFLAGS-tst-ibm128-efgcvt.c += -mabi=ibmlongdouble -Wno-psabi
 
 CFLAGS-tst-ieee128-warn.c += -mfloat128 -mabi=ieeelongdouble -Wno-psabi
 CFLAGS-tst-ieee128-error.c += -mfloat128 -mabi=ieeelongdouble -Wno-psabi
+CFLAGS-tst-ieee128-efgcvt.c += -mfloat128 -mabi=ieeelongdouble -Wno-psabi
 
 tests-container += test-syslog-ieee128 test-syslog-ibm128
 CFLAGS-test-syslog-ieee128.c += -mfloat128 -mabi=ieeelongdouble -Wno-psabi
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/Versions b/sysdeps/ieee754/ldbl-128ibm-compat/Versions
index da8e0ce7ee..b4609c99f7 100644
--- a/sysdeps/ieee754/ldbl-128ibm-compat/Versions
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/Versions
@@ -224,5 +224,11 @@ libc {
 
     __strfmonieee128;
     __strfmon_lieee128;
+
+    __qecvtieee128;
+    __qfcvtieee128;
+    __qgcvtieee128;
+    __qecvtieee128_r;
+    __qfcvtieee128_r;
   }
 }
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt.c b/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt.c
new file mode 100644
index 0000000000..1e9fd16db2
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt.c
@@ -0,0 +1,52 @@
+/* IEEE binary128 versions of *cvt functions.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* When in IEEE long double mode, call ___ieee128_sprintf.  */
+#include <stdio.h>
+typeof (sprintf) ___ieee128_sprintf attribute_hidden;
+#define SPRINTF ___ieee128_sprintf
+
+/* Declare internal functions: ___qecvtieee128_r and ___qfcvtieee128_r,
+   built from a different compiling unit, and called from here.  */
+#include <stdlib.h>
+typeof (qecvt_r) ___qecvtieee128_r;
+typeof (qfcvt_r) ___qfcvtieee128_r;
+
+/* Rename the static buffers and pointer, otherwise the IEEE long double
+   variants of qecvt and qfcvt would reuse the same buffers and pointer
+   as their non-IEEE long double counterparts.  */
+#define qecvt_buffer qecvtieee128_buffer
+#define qfcvt_buffer qfcvtieee128_buffer
+#define qfcvt_bufptr qfcvtieee128_bufptr
+
+#define ECVT __qecvtieee128
+#define FCVT __qfcvtieee128
+#define GCVT __qgcvtieee128
+#define __ECVT ___qecvtieee128
+#define __FCVT ___qfcvtieee128
+#define __GCVT ___qgcvtieee128
+#define __ECVT_R ___qecvtieee128_r
+#define __FCVT_R ___qfcvtieee128_r
+#include <efgcvt-ldbl-macros.h>
+#include <efgcvt-template.c>
+
+#define cvt_symbol(local, symbol) \
+  strong_alias (local, symbol)
+cvt_symbol (___qfcvtieee128, __qfcvtieee128);
+cvt_symbol (___qecvtieee128, __qecvtieee128);
+cvt_symbol (___qgcvtieee128, __qgcvtieee128);
diff --git a/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt_r.c b/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt_r.c
new file mode 100644
index 0000000000..1a5e43972f
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-128ibm-compat/ieee128-qefgcvt_r.c
@@ -0,0 +1,34 @@
+/* IEEE binary128 versions of reentrant *cvt_r functions.
+   Copyright (C) 2018 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* When in IEEE long double mode, call ___ieee128_snprintf.  */
+#include <stdio.h>
+typeof (snprintf) ___ieee128_snprintf attribute_hidden;
+#define SNPRINTF ___ieee128_snprintf
+
+#define ECVT_R __qecvtieee128_r
+#define FCVT_R __qfcvtieee128_r
+#define __ECVT_R ___qecvtieee128_r
+#define __FCVT_R ___qfcvtieee128_r
+#include <efgcvt-ldbl-macros.h>
+#include <efgcvt_r-template.c>
+
+#define cvt_symbol(local, symbol) \
+  strong_alias (local, symbol)
+cvt_symbol (___qfcvtieee128_r, __qfcvtieee128_r);
+cvt_symbol (___qecvtieee128_r, __qecvtieee128_r);